/// @cond EO_CXX_EO_IMPL

inline void elm::flip::interaction_direction_hitsize_set(Elm_Flip_Direction dir_, double hitsize_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_interaction_direction_hitsize_set(dir_, hitsize_));
}

inline double elm::flip::interaction_direction_hitsize_get(Elm_Flip_Direction dir_) const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_interaction_direction_hitsize_get(dir_));
   return _tmp_ret;
}

inline void elm::flip::interaction_direction_enabled_set(Elm_Flip_Direction dir_, bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_interaction_direction_enabled_set(dir_, ::efl::eolian::to_c(enabled_)));
}

inline bool elm::flip::interaction_direction_enabled_get(Elm_Flip_Direction dir_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_interaction_direction_enabled_get(dir_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::flip::go(Elm_Flip_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_go(mode_));
}

inline void elm::flip::go_to(bool front_, Elm_Flip_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_go_to(::efl::eolian::to_c(front_), mode_));
}

inline Elm_Flip_Interaction elm::flip::interaction_get() const
{
   Elm_Flip_Interaction _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_interaction_get());
   return _tmp_ret;
}

inline void elm::flip::interaction_set(Elm_Flip_Interaction mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_interaction_set(mode_));
}

inline bool elm::flip::front_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_front_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::flip::interaction_direction_hitsize_set(Elm_Flip_Direction dir_, double hitsize_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_interaction_direction_hitsize_set(dir_, hitsize_));
}

inline double eo_cxx::elm::flip::interaction_direction_hitsize_get(Elm_Flip_Direction dir_) const
{
   double _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_interaction_direction_hitsize_get(dir_));
   return _tmp_ret;
}

inline void eo_cxx::elm::flip::interaction_direction_enabled_set(Elm_Flip_Direction dir_, bool enabled_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_interaction_direction_enabled_set(dir_, ::efl::eolian::to_c(enabled_)));
}

inline bool eo_cxx::elm::flip::interaction_direction_enabled_get(Elm_Flip_Direction dir_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_interaction_direction_enabled_get(dir_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::flip::go(Elm_Flip_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_go(mode_));
}

inline void eo_cxx::elm::flip::go_to(bool front_, Elm_Flip_Mode mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_go_to(::efl::eolian::to_c(front_), mode_));
}

inline Elm_Flip_Interaction eo_cxx::elm::flip::interaction_get() const
{
   Elm_Flip_Interaction _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_interaction_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::flip::interaction_set(Elm_Flip_Interaction mode_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_flip_interaction_set(mode_));
}

inline bool eo_cxx::elm::flip::front_visible_get() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_flip_front_visible_get());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::eo_cxx::elm::flip::operator ::elm::flip() const
{
   return *static_cast<::elm::flip const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::flip::operator ::elm::flip&()
{
   return *static_cast<::elm::flip*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::flip::operator ::elm::flip const&() const
{
   return *static_cast<::elm::flip const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_flip_interaction_direction_hitsize_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Flip_Direction dir_, double hitsize_)
{
   try
      {
         static_cast<T*>(self->this_)->interaction_direction_hitsize_set(dir_, hitsize_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
double elm_flip_interaction_direction_hitsize_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Flip_Direction dir_)
{
   try
      {
         return static_cast<T*>(self->this_)->interaction_direction_hitsize_get(dir_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         double _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_flip_interaction_direction_enabled_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Flip_Direction dir_, Eina_Bool enabled_)
{
   try
      {
         static_cast<T*>(self->this_)->interaction_direction_enabled_set(dir_, ::efl::eolian::to_cxx<bool>(enabled_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_flip_interaction_direction_enabled_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Flip_Direction dir_)
{
   try
      {
         return static_cast<T*>(self->this_)->interaction_direction_enabled_get(dir_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_flip_go_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Flip_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->go(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
void elm_flip_go_to_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eina_Bool front_, Elm_Flip_Mode mode_)
{
   try
      {
         static_cast<T*>(self->this_)->go_to(::efl::eolian::to_cxx<bool>(front_, std::tuple<std::false_type>()), mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Flip_Interaction elm_flip_interaction_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->interaction_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Flip_Interaction _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_flip_interaction_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Flip_Interaction mode_)
{
   try
      {
         static_cast<T*>(self->this_)->interaction_set(mode_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_flip_front_visible_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->front_visible_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::flip >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::container >::template type<T>
   {
      virtual void interaction_direction_hitsize_set(Elm_Flip_Direction dir_, double hitsize_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_flip_interaction_direction_hitsize_set(dir_, hitsize_));
      }

      virtual double interaction_direction_hitsize_get(Elm_Flip_Direction dir_)
      {
         double _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_flip_interaction_direction_hitsize_get(dir_));
            return _tmp_ret;
      }

      virtual void interaction_direction_enabled_set(Elm_Flip_Direction dir_, bool enabled_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_flip_interaction_direction_enabled_set(dir_, ::efl::eolian::to_c(enabled_)));
      }

      virtual bool interaction_direction_enabled_get(Elm_Flip_Direction dir_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_flip_interaction_direction_enabled_get(dir_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void go(Elm_Flip_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_flip_go(mode_));
      }

      virtual void go_to(bool front_, Elm_Flip_Mode mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_flip_go_to(::efl::eolian::to_c(front_), mode_));
      }

      virtual Elm_Flip_Interaction interaction_get()
      {
         Elm_Flip_Interaction _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_flip_interaction_get());
            return _tmp_ret;
      }

      virtual void interaction_set(Elm_Flip_Interaction mode_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_flip_interaction_set(mode_));
      }

      virtual bool front_visible_get()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_flip_front_visible_get());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::elm::flip >
{
   static constexpr int value = 
#if defined(FLIP_PROTECTED) && defined(FLIP_BETA)
      9
#elif defined(FLIP_PROTECTED)
      9
#elif defined(FLIP_BETA)
      9
#else
      9
#endif
      + operation_description_class_size<::elm::container >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::flip>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_interaction_direction_hitsize_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_interaction_direction_hitsize_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_interaction_direction_hitsize_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_interaction_direction_hitsize_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_interaction_direction_enabled_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_interaction_direction_enabled_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_interaction_direction_enabled_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_interaction_direction_enabled_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_go_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_go);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_go_to_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_go_to);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_interaction_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_interaction_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_interaction_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_interaction_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_flip_front_visible_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_flip_front_visible_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::container>(), &ops[operation_description_class_size< ::elm::flip >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::flip>)
{
   return (ELM_FLIP_CLASS);
}

} } }

/// @endcond

